# Call of Duty: Black Ops 2 Zombies - Reimagined

## Created by: Jbleezy

[YouTube](https://youtube.com/ItsJbirdJustin)

[Twitch](https://twitch.tv/Jbleezy)

[Twitter](https://twitter.com/ItsJbleezy)

[Discord](https://discord.io/Jbleezy)

[Donate](https://paypal.me/Jbleezy)

## Change Notes

## General
* Removed fog
* Disabled depth of field
* Increased level of detail at longer distances
* In-game menu no longer disabled instantly when the game ends

## HUD
* Enemy counter displayed on top left of screen
* Timer displayed on top right of screen
* Health bar displayed on bottom left of screen
* Current zone displayed on bottom left of screen
* Increased waypoint offset from top of screen
* Changed player waypoint location to be center of player instead of top of player
* Increased distance between revive waypoint arrow and icon
* Bleedout bar displayed when downed
* Revive bar displayed for downed player
* Changed revive bar color to blue
* Player needs to be revived text updates to new player instantly

## Players
* Unlimited sprint
* Increased health from 100 to 150
* Self revives in solo are active whenever the player has at least 1 perk
* 100% backwards move speed
* Decreased sprint time needed to be able to dive from 0.25 seconds to 0.1 seconds
* Can move immediately after diving
* Can dive again right away after just diving
* Increased melee range by 16% (same as Black Ops 1)
* Disabled melee lunging
* Decreased normal health regeneration delay from 2.4 seconds to 2 seconds
* Decreased low health regeneration delay from 5 seconds to 4 seconds
* Normal health regeneration rate is no longer instant
* Changed health regeneration rate to 100 health per second (normally fully restored health in 0.5 seconds)
* Fall damage no longer increases when max health is increased
* Added blood fx when at or below 20% health
* Removed blur when getting damaged
* Removed shellshock when getting damaged from grenades
* No longer killed when landing on top of another player
* Ignored by enemies for 1 second after being revived
* Weapon is no longer switched after reviving if player switched weapons during revive
* No longer gain points back on self revives
* Respawn near random player (normally respawns near the same player every time)
* Can shoot while looking at other players
* Increased mantle speed
* Increased ladder climb speed
* Start with Semtex on maps that have Semtex
* Entering and exiting last stand no longer refills last stand weapon clip automatically
* Decreased friendly player name fade out time from 1.5 seconds to 0.25 seconds
* Removed enemy player name fade in time

## Zombies
* Health capped at 100,000
* Changed height to 64 on all maps (normally either 48 or 72)
* Attracted towards points of interest immediately
* Removed walkers in high rounds
* Removed headless zombies
* Neck counts as headshot

### Denizens
* Decreased maximum amount that can be spawned at once from 2 to 1
* Decreased minimum number of melees to kill from 5 to 3
* Decreased minimum number of melees to kill with Bowie Knife from 3 to 2
* Decreased minimum number of melees to kill with Galvaknuckles from 2 to 1
* No longer automatically runs away when player is first attacked in solo
* Removed hint when player is first attacked in solo

### Brutus
* No longer receives additional damage from Ray Gun Mark 2

## Weapons
* Switch to melee weapon by pressing the Previous Scorestreak button (same button as the Time Bomb and Maxis Drone)
* Inspect weapon by pressing the Alt Fire button
* Changed grenade damage scalar to 25 multiplied by round number (normally random number between 100 and 200 added by round number)
* Capped grenade damage scalar at 1500
* Changed projectile weapon damage scalar to 50 multiplied by round number (normally random number between 0 and 100 multiplied by round number)
* Capped projectile weapon damage scalar at 3000
* Changed placeable mine damage scalar to 150 multiplied by round number (normally random number between 100 and 200 multiplied by round number)
* Capped placeable mine damage scalar at 9000
* Disabled sniper scope sway

### AN-94
* Increased weapon cost from 1200 to 1500

### B23R
* Changed weapon cost to 900 on all maps

### Ballistic Knife
* Projectiles are no longer picked up by other players
* Projectiles can be picked up while the weapon is not reloaded
* Projectiles can be picked up while the player is not on the ground

### Executioner
* Increased penetration

### HAMR
* Decreased recoil

### M1216
* Increased penetration

### M1911
* Upgraded: given as last stand pistol above all others except Ray Gun Mark 2
* Upgraded: decreased last stand ammo from 2 clips to 1 clip

### M1927
* Decreased ammo cost from 800 to 750

### M8A1
* Decreased recoil

### MTAR
* Decreased recoil

### Remington 870
* Changed weapon cost to 1200 on all maps
* Increased penetration

### RPD
* Decreased recoil

### S12
* Increased penetration

### SMR
* Increased damage by 100%
* Removed ADS spread

### Type 25
* Decreased recoil

### War Machine
* Unupgraded: grenades explode on impact

### EMP Grenade
* No longer disables HUD
* Disables player's perks for 30 seconds
* Added fx to EMP'd players
* Decreased zombie EMP radius by 30% (same radius as perk EMP)
* Sprinting no longer wakes up EMP'd zombies

### Claymore
* Can be repurchased
* Increased max amount that can be placed from 12 to 20

### Ray Gun
* Unupgraded: increased impact damage from 1000 to 1500 (same as max splash damage)
* Upgraded: increased impact damage from 1000 to 2000 (same as max splash damage)
* No longer limited to 4 players

### Ray Gun Mark 2
* Same probability to obtain as other weapons
* Can be obtained if player has Ray Gun
* Limited to 1 player on all maps
* Decreased last stand ammo from 3 clips to 1 clip

### Jet Gun
* Kills multiple enemies significantly faster
* Kills enemies that are in the ground, traversing, or behind barriers
* Awards points for kills
* Cools down twice as fast
* Cools down while not holding weapon
* Heats up when firing while meleeing
* No longer kills when not firing
* No longer automatically switched to weapon when picked up
* No longer disassembles when overheated
* Weapon is taken when overheated

### Sliquifier
* Added upgraded version
* Kills on any round (normally stops killing after round 100)
* Removed additional goo created by chain kills

### Paralyzer
* Kills on any round

### Blundergat
* Kills on any round

### Acid Gat
* Kills on any round

### Staffs
* Upgrade only requires collecting souls in The Crazy Place
* Can no longer collect souls in The Crazy Place from staff kills
* Can collect souls in The Crazy Place after upgrading to fill 5% of max ammo per soul
* Get full ammo when initially picked up after upgrading (normally missing one clip)
* Max ammo no longer fills clip ammo

## Wallbuys
* Increased trigger radius
* Decreased upgraded ammo cost from 4500 to 2500
* Lethal grenade hint string no longer displays "ammo" after purchasing

## Mystery Box
* Decreased weapon pickup time from 12 seconds to 9 seconds
* Moves to new location instantly
* Special sound no longer plays when obtaining the Ray Gun
* Special sound plays when obtaining a limited weapon

## Perks
* Removed perk limit
* No longer deactivated if the perk machine is powered off
* Added high qualty perk icons to all maps

### Juggernog
* Increases current health by 100 upon purchase (normally sets current health to max)

### Quick Revive
* No longer automatically powered on in solo
* Increased cost in solo from 500 to 1500
* Decreases revive time by 33.33%
* Decreases health regeneration delay by 25%

### Speed Cola
* Aim twice as fast
* Switch weapons twice as fast
* Throw grenades twice as fast

### Double Tap
* Removed shooting 2 bullets for every shot
* Increases bullet damage by 50%

### Stamin-Up
* Increased cost from 2000 to 2500
* Move 7% faster (normally only sprint 10% faster)

### Deadshot Daiquiri
* Increases bullet headshot damage by 100%
* Move faster while aiming
* Decreases sprint recovery time

### Mule Kick
* Added additional weapon indicator
* Additional weapon is given back when perk is reacquired
* Stowed weapons refill ammo from stock over time

### Tombstone Soda
* Added in solo
* Added powerup waypoint
* Powerup no longer removed when revived
* Powerup removed when downed
* Unlimited time to pick up powerup
* Changed powerup fx color to blue
* Powerup gets destroyed by EMP Grenades
* Restores all weapons properly
* Disabled suicide option when player is down
* Flipped perk icon

### Who's Who
* Gain all other perks the player had before going down when entering Who's Who mode
* Revive twice as fast when in Who's Who mode
* No longer gives the player Claymores when entering Who's Who mode if the player purchased Claymores

### Electric Cherry
* Removed cooldown after being used multiple times in a row

### Vulture-Aid
* Stink areas no longer activate while the player is moving

## Pack-a-Punch
* Decreased weapon pickup time from 15 seconds to 12 seconds

## Powerups

### Insta Kill
* Grabbing while already active adds to timer instead of resetting timer

### Double Points
* Grabbing while already active adds to timer instead of resetting timer

### Nuke
* Kills all zombies instantly
* Counts as kills for player who grabbed it

### Carpenter
* Removed

### Meat
* Able to drop when players are down
* Changed powerup fx color to blue
* Decreased time on ground from 16 seconds to 10 seconds
* Message shows when the meat is on a player
* Meleeing while the meat is moving no longer grabs the meat
* Meleeing while the meat is moving throws the meat
* Meleeing while the meat is moving activates more consistently
* Removed pick up trigger

## Persistent Upgrades
* Removed

## Buildables
* Added purchase cost
* Parts automatically picked up
* Zombies no longer attack (except Zombie Shield)
* Destroyed by taking 1500 damage
* No longer destroyed by 2 grenades

### Electric Trap
* No longer needs to be powered by a Turbine
* Gets destroyed after being deployed for 30 seconds
* Kills on any round (normally stops killing after round 50)
* Can kill unlimited zombies at once
* No longer kills players without Juggernog instantly
* Decreased player damage from 75 to 25
* Decreased player shellshock time from 2.5 seconds to 1.25 seconds
* Decreased startup time from 2 seconds to 0.5 seconds

### Turret
* No longer needs to be powered by a Turbine
* Gets destroyed after being deployed for 30 seconds
* Kills on any round in 1-4 shots (normally does 1200 damage max)
* No longer damages players
* Fire type changed from burst fire to continuous fire
* Fixed an issue where the Turret sounds would continue playing after being picked up

### Trample Steam
* No longer gets destroyed from kills
* Gets destroyed after activating 15 times

### Subsurface Resonator
* No longer needs to be powered by a Turbine
* No longer gets destroyed from kills
* Gets destroyed after being deployed for 30 seconds
* Fires every 2 seconds (normally has a longer delay depending on the amount of kills from the previous fire)

### Head Chopper
* No longer gets destroyed from kills
* Gets destroyed after activating 15 times

### Maxis Drone
* Switches back to correct weapon after deploying

## Bank
* Deposited points resets each game
* Gain 10% interest on deposited points at the end of each round
* No longer costs 100 points to withdraw
* Players can deposit and withdraw less than 1000 points
* Account balance is shown when depositing, withdrawing, and going near the triggers
* Disabled trading points

## Weapon Locker
* Stored weapon resets each game
* Stored weapon gains max ammo at the end of each round

## Maps

### Tranzit
* Any door that requires a Turbine to open is automatically open whenever the power is on
* Lava in starting area activates after the power is on
* Lava destroys grenades instantly
* Decreased brightness at Power Station
* Power switch automatically crafted
* Pack-a-Punch automatically crafted
* Navcard table automatically crafted
* Grief: added Ballistic Knife, Ray Gun, and Ray Gun Mark 2 to the Mystery Box
* Fixed a zombie riser spawn point at Outside Power Station being too high above ground
* Fixed a zombie pathing exploit at Town in Bookstore

#### Bus Depot
* Lava in starting area activates immediately
* Power doors open when door is opened
* Lava pit is accessible

#### Diner
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, MP5, Galvaknuckles
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap

#### Farm
* Zombies spawn in the Farm zone when in the Barn zone
* Replaced Olympia wallbuy with Remington 870 wallbuy
* Replaced Galvaknuckles wallbuy with Claymore wallbuy (also added to Grief)
* Grief: removed player spawns near gate

#### Power Station
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, AK74u, MP5, Bowie Knife
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap, Tombstone Soda
* Pack-a-Punch

#### Town
* Moved Quick Revive to Stamin-Up's location on Town
* Moved Stamin-Up to its location on Tranzit
* Moved Tombstone Soda to the laundry room front door
* Grief: added Tombstone Soda

#### Tunnel
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, M16, MP5, Semtex
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap, Stamin-Up
* Pack-a-Punch

### Die Rise
* Moved weapon locker to the downstairs fridge
* Zombies no longer spawn in the Upper Blue Highrise zone when in the Trample Steam zone
* Zombies no longer spawn in the zone next to the AN94 when in the AN94 zone while the debris is closed
* Navcard table automatically crafted

### Mob of the Dead
* 1 afterlife max in solo
* Acid Trap kills on any round (normally stops killing after round 158 on PC)
* Tower Trap kills on any round in 1 shot
* Upgraded Tower Trap kills on any round in 1-2 shots
* Upgraded Tower Trap stays upgraded until the end of the round
* Plane parts are shared in coop
* Plane parts must be all acquired to craft
* Plane fuel automatically picked up
* Players no longer respawn in the Acid Trap

#### Cell Block
* Added Smoke Grenades to the Mystery Box
* Added Richtofen Head meat powerup model

### Buried
* Power automatically on
* Removed Turbine
* Removed Sloth barricades
* Sloth can no longer be unlocked
* Ghosts no longer spawn a free perk powerup if any player gets damaged by the ghosts
* Fountain portal automatically active
* Navcard table automatically crafted
* Players can no longer get into the corner next to Juggernog
* Fixed hint strings on buildables when purchased

#### Borough
* Tunnels disabled
* Players spawn at Stables
* Mystery Box initially spawns at a random location
* Added B23R, M16, Claymore, and Bowie Knife wallbuys at their locations on Buried
* Added PDW wallbuy at Morgue
* Added SVU wallbuy at Church
* Moved Quick Revive to Speed Cola's location on Borough
* Moved Speed Cola to its location on Buried
* Moved Stamin-Up to Vulture Aid's location on Buried

### Origins
* Door prices in solo cost the same as in coop
* Shovels automatically picked up
* Gramophone and records automatically picked up
* Der Wunderfizz: increased cost from 1500 to 2500
* Der Wunderfizz: all perks have an equal chance of being obtained
* Rituals of the Ancients: spend points challenge reward changed from Double Tap perk to a random perk that the player does not have (perk does not change if reward is reopened)
* Soul boxes: decreased kill requirement from 30 to 20
* Perk bottle dig spots: give random perk
* Perk bottle dig spots: visible and diggable without Zombie Blood
* Perk bottle dig spots: increased number of rounds for next dig spot to spawn from 1 to 4
* Ascend from darkness quest step: staffs can be placed at any staff holder
* Ascend from darkness quest step: fixed an issue where staffs were able to be picked up at their build location when placed in the staff holders
* Rain fire quest step: button no longer deactivates

## Game Modes

### Encounter
* Group of competitive game modes
* Unlimited zombies
* 2500 health zombies (25000 health Brutus)
* 0.5 second zombie spawn rate
* Only sprinting zombies
* Unlimited powerups
* Unlimited barrier rebuild points
* Decreased stun time of weapons from 0.75 seconds to 0.375 seconds
* Meleeing enemy players that are crouched pushes 25% less
* Meleeing enemy players that are prone pushes 50% less
* Meleeing enemy players that are reviving pushes 50% less
* Meleeing enemy players that are already stunned from weapons will push and restun them
* Ballistic knife projectile pushes enemy players
* Claymores are no longer triggered by enemy players
* Stun fx is linked to the player
* Stun fx shows in the correct position for projectiles
* Stunning enemy players steals 50 points from them
* Meleeing enemy players steals 100 points from them
* Downing enemy players awards 500 points
* Bleeding out enemy players awards 1000 points to all teammates
* Landing on top of an enemy player that is prone downs them
* Increased max radius for landing on top of an enemy player by 16.67%
* Decreased max height for landing on top of an enemy player by 50%
* Max Ammo: decreased amount of ammo given from max stock to one clip
* Max Ammo: unloads clip of all enemy players' weapons
* Double Points: decreased duration from 30 seconds to 15 seconds
* Double Points: enemy players gain half points
* Insta Kill: decreased duration from 30 seconds to 15 seconds
* Insta Kill: enemy players deal half damage
* Nuke: deals 80 damage to all alive enemy players
* Nuke: makes all downed enemy players bleed out
* Added teammate waypoint icons
* Added kill feed (includes downs, revives, and bleed outs)
* Added player kills on scoreboard (replaces headshots)
* Added player downed and bled out icons on scoreboard
* Added intro text
* Announcer audio always plays
* Last player alive audio only plays for the player who is alive instead of every player on the team

#### Grief
* Gain score by making enemy players bleed out
* Make 25 enemy players bleed out to win the game
* Players respawn after being down for 10 seconds
* Players retain perks

#### Search & Rezurrect
* Win rounds by getting all enemy players down
* Win 3 rounds to win the game
* Tie round if both teams die within 5 seconds of eachother
* Players start each round with at least 10000 points
* Enemies remaining audio and text displays when enemy players down instead of when enemy players bleed out
* Enemies remaining text is removed when new text is displayed
* Added new audio when enemy players bleed out
* Players do not get their weapons back on round reset if they bled out
* Round reset properly restores dual wield weapon left clip ammo, alternative weapon ammo, and equipment
* Spawn points are assigned to a team
* Teams switch spawn points each round
* Players respawn at initial spawn points

#### Race
* Gain score by getting kills
* Get 500 kills to win the game
* Starts at round 1
* Round increments every 30 seconds (up to round 20)
* Players gain 500 points at the beginning of each round
* Players respawn after being down for 10 seconds

#### Containment
* Gain score by being the team with the most players alive in the containment zone
* Gain 250 score to win the game
* Contested if both teams have the same amount of players alive in the containment zone
* Both teams gain score at half-rate when contested
* Zombies only go after players in the containment zone
* Players in the containment zone gain 50 points when their team gains score
* Players respawn after being down for 10 seconds
* Players retain perks

#### Meat
* Gain score by being the team holding the meat
* Gain 200 score to win the game
* Meat powerup always spawns from the first zombie killed
* All zombies go after the player holding the meat
* Player holding the meat moves at 60% speed
* Player holding the meat gains 100 points when their team gains score
* Downing while holding the meat drops it as a powerup
* Throwing the meat on the ground drops it as a powerup
* Throwing the meat onto another player makes them hold the meat
* Players respawn after being down for 10 seconds
* Players retain perks

### Encounter Pro
* 100 player health
* Added Juggernog and Speed Cola on all maps
* Removed all perks except for Juggernog and Speed Cola
* Removed Pack-a-Punch
* Removed Mystery Box
* Removed powerups
* Removed buildables
* Removed unlimited sprint
* Disabled Semtex and Claymore wallbuys

## Launching New Maps

* Copy and paste the following commands into the console

### Survival on Diner
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation diner```

### Survival on Power Station
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation power```

### Survival on Tunnel
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation tunnel```

### Grief on Diner
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation diner```

### Grief on Power Station
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation power```

### Grief on Tunnel
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation tunnel```

## Launching New Game Modes

* By default, a random game mode will be chosen when launching Grief
* Copy and paste the following commands into the console to choose a specific game mode

### Grief
* ```set ui_gametype_obj zgrief```

### Search & Rezurrect
* ```set ui_gametype_obj zsnr```

### Race
* ```set ui_gametype_obj zrace```

### Containment
* ```set ui_gametype_obj zcontainment```

### Meat
* ```set ui_gametype_obj zmeat```